/**
 * MCS Media Computer Software
 * Copyright 2019 by Wilfried Klaas
 * Project: SPSEmulator
 * File: testWebSessionModel.java
 * EMail: W.Klaas@gmx.de
 * Created: 29.01.2019 wklaa_000
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */
package de.mcs.tools.sps.emulator.model;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import de.mcs.utils.JacksonUtils;

/**
 * @author wklaa_000
 *
 */
class testWebSessionModel {

  /**
   * @throws java.lang.Exception
   */
  @BeforeEach
  void setUp() throws Exception {
  }

  @Test
  void test() throws IOException {
    WebSessionModel webSessionModel = new WebSessionModel();

    List<String> allLines = Files.readAllLines(new File("examples/Blink.tps").toPath());
    webSessionModel.getProgram().setSource(allLines.toArray(new String[0]));

    String modelJson = JacksonUtils.getJsonMapper().writeValueAsString(webSessionModel);
    System.out.println(modelJson);
    System.out.printf("size: %d\r\n", modelJson.length());

    WebSessionModel sessionModel = JacksonUtils.getJsonMapper().readValue(modelJson, WebSessionModel.class);

    String newModelJson = JacksonUtils.getJsonMapper().writeValueAsString(sessionModel);
    System.out.println(newModelJson);
    System.out.printf("size: %d\r\n", newModelJson.length());
  }

  @Test
  void testme() {
    int value = 2;
    System.out.printf("0x%04x \r\n", value);
  }
}
