/**
 * 
 */
package de.mcs.tools.sps.emulator;

import java.util.List;

/**
 * a single Command for the emulator
 * 
 * @author w.klaas
 *
 */
public interface SPSCommand {

  /**
   * @return the name of this command
   */
  String getName();

  /**
   * @return the short Mnemonic
   */
  String getMnemonic();

  /**
   * @return the byte code for this command
   */
  byte getCommandByte();

  /**
   * @return a lsit of all supported datas of this command
   */
  List<SPSCommandData> getCommandDatas();

}
